/******************************************************************************
    (c) 1995-1998 E.M. Serrat          emserrat@geocities.com
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*******************************************************************************/

#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>
#include <netdnet/dn.h>
#include <netdnet/dnetdb.h>

static char             nodetag[80],nametag[80],nodeadr[80],nodename[80];
static char             asc_addr[6];
/*--------------------------------------------------------------------------*/
char *dnet_htoa(const struct dn_naddr *addr)
{
	FILE		*dnhosts;
	char		nodeln[80];

	sprintf(asc_addr,"%d.%d",(addr->a_addr[1] >> 2),
		(((addr->a_addr[1] & 0x03) << 8) | addr->a_addr[0]));

	if ((dnhosts = fopen("/etc/decnet.conf","r")) == NULL)
	{
		printf("dnet_htoa: Can not open /etc/decnet.conf\n");
		return 0;
	}
	while (fgets(nodeln,80,dnhosts) != NULL)
	{
		sscanf(nodeln,"%s%s%s%s\n",nodetag,nodeadr,nametag,nodename);
		if (strncmp(nodetag,"#",1) != 0)	
		{
		   if (((strcmp(nodetag,"executor") != 0) &&
	    	       (strcmp(nodetag,"node")     != 0)) ||
		       (strcmp(nametag,"name")     != 0))
		   {
		       printf("dnet_htoa: Invalid decnet.conf syntax\n");
			 fclose(dnhosts);
		       return 0;
		   }
		   if (strcmp(nodeadr,asc_addr) == 0) 
		   {
			fclose(dnhosts);
			return nodename;
		   }
		}
	}
	fclose(dnhosts);
	return asc_addr;
}
/*--------------------------------------------------------------------------*/
